import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

public abstract class AbstractConstant
    implements java.io.Serializable{

   //the internal representation of the constant     
   private transient String _fieldName;

   /**
   * get the field name for this instance
   * write it to the stream
   */
   private void writeObject(java.io.ObjectOutputStream out) 
        throws java.io.IOException {
           
      Class clazz=getClass();
      Field [] f=clazz.getDeclaredFields();
	
	for(int i=0;i<f.length;i++){
	    try{
              int mod=f[i].getModifiers();
              
              if(Modifier.isStatic(mod) && Modifier.isFinal(mod)
                    && Modifier.isPublic(mod)){
              
	        if(this==f[i].get(null)){
                    String fName=f[i].getName();
                    out.writeObject(fName);
	        }
              }
	    }catch(IllegalAccessException ex){
	        throw new java.io.IOException(ex.getMessage());
	    }
	}
  }

  /**
   * read the serialized field name and assign to
   * _fieldName
   */
  private void readObject(java.io.ObjectInputStream in)
     throws java.io.IOException{
    try{
        
        _fieldName=(String)in.readObject();   
    }catch(ClassNotFoundException ex){
        throw new java.io.IOException(ex.getMessage());
    }
  }

  /**
   * replace the deserialized instance with the
   * local static instance to allow correct
   * usage of == operator
   */
  public Object readResolve()
      throws java.io.ObjectStreamException{
      
       try{
           
           Class clazz=getClass();
           Field f=clazz.getField(_fieldName);
           return f.get(null); 
      }catch(Exception ex){
          ex.printStackTrace();
        throw new java.io.InvalidObjectException(
                 "Failed to resolve object");
      }
     
  }
}

