
import java.io.*;

public class ConstantTester {
    
    private static final String FNAME="const.ser";
    private static final NumberConstant CONST=NumberConstant.TWO;
    
    public static void main (String args[]) 
        throws Exception{
            
        if(args.length==0){
            System.err.println("Requires either -read or -write");
	    System.err.println("\nTo test, use -write to create the" +
			       " const.ser file\nand then use the" +
			       " -read option to try to read it back.\n");
            System.exit(1);
        }
        
        if(args[0].equals("-write")){
            save(CONST);
        }else if(args[0].equals("-read")){
            NumberConstant nc=(NumberConstant)load();
            if(CONST==nc){
                System.out.println("Matched using ==");
            }else{
                System.out.println("Failed to match using ==");
            }
        }else{
          System.err.println("Invalid parameter");
        }
        
    }
    static Object load()
        throws IOException, ClassNotFoundException{
        
        Object o=null;
        
        FileInputStream fis=new FileInputStream(FNAME);
        ObjectInputStream ois= new ObjectInputStream(fis);
        o=ois.readObject();
        ois.close();
        return o;
        
    }
    static void save(Object o)
        throws IOException{
        FileOutputStream fos=new FileOutputStream(FNAME);
        ObjectOutputStream oos=new ObjectOutputStream(fos);
        oos.writeObject(o);
        oos.flush();
        oos.close();
    }

}
